Lowest Common Ancestor of a Binary Search Tree Leetcode

Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v and w as descendants (where we allow a node to be a descendant of itself).”

        _______6______
       /              \
    ___2__          ___8__
   /      \        /      \
   0      _4       7       9
         /  \
         3   5

For example, the lowest common ancestor (LCA) of nodes 2 and 8 is 6. Another example is LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.

 

这道题逻辑上很简单,但我的代码写的很冗余,看过top solution的代码改良之后好多了。。。兼顾了可读性与简洁性。
public class Solution {
    public TreeNode lowestCommonAncestor(TreeNode root, TreeNode p, TreeNode q) {
        if (root == null) {
            return null;
        }
        if ((p.val - root.val) * (q.val - root.val) <= 0) {
            return root;
        }
        return lowestCommonAncestor(p.val - root.val < 0 ? root.left : root.right, p, q);
    }
}

有的时候可以适当合并代码,使得代码更简洁。

 

重做的时候由于定式思维,没有考虑到这个是bst,直接当普通二叉树做了。。。

先把这个答案放这里吧。

public class Solution {
    public TreeNode lowestCommonAncestor(TreeNode root, TreeNode p, TreeNode q) {
        if (root == null) {
            return null;
        }
        if (root == p || root == q) {
            return root == p ? p : q;
        }
        
        TreeNode left = lowestCommonAncestor(root.left, p, q);
        TreeNode right = lowestCommonAncestor(root.right, p, q);
        
        if (left == null) {
            return right;
        }
        if (right == null) {
            return left;
        }
        return root;
        
    }
}

 然后按照这个题目又写了一次,还是不如当初改进版简洁。。。

放个C++写法吧:

/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode(int x) : val(x), left(NULL), right(NULL) {}
 * };
 */
class Solution {
public:
    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
        if (root == NULL || (root -> val - p -> val) * (root -> val - q -> val) <= 0) {
            return root;
        }
        return lowestCommonAncestor(root -> val - p -> val > 0 ? root -> left : root -> right, p, q);
    }
};

非递归的方法:

class Solution {
public:
    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
        while (root != NULL) {
            if ((root -> val - p -> val) * (root -> val - q -> val) <= 0) {
                return root;
            }
            root = root -> val - p -> val > 0 ? root -> left : root -> right;
        }
        return root;
    }
};

 

posted @ 2017-01-27 12:27  璨璨要好好学习  阅读(113)  评论(0编辑  收藏  举报